      SUBROUTINE OULAN_FOUR(KANNEE,KMOIS,KJOUR,KHEURE,KHHMNM1,KHHMNP1,
     &                      KHHMNM2,KHHMNP2,KHHMNCO,CDDATDEB,CDDATFIN)
!-----------------------------------------------------------------------
!  SP OULAN_FOUR : calcul des fourchettes temporelles
!  -------------
!  Auteur        : Ph. Caille                                    11/94
!  Modifications :
!-----------------------------------------------------------------------
      CHARACTER   CDDATDEB(3)*14,CDDATFIN(4)*14
      INTEGER     IDJM(0:12),IMAV(12)

      IDJM( 0) = 31
      IDJM( 1) = 31
      IDJM( 2) = 28
      IDJM( 3) = 31
      IDJM( 4) = 30
      IDJM( 5) = 31
      IDJM( 6) = 30
      IDJM( 7) = 31
      IDJM( 8) = 31
      IDJM( 9) = 30
      IDJM(10) = 31
      IDJM(11) = 30
      IDJM(12) = 31
      IF ( MOD( KANNEE , 4 ).EQ.0 ) IDJM(2) = 29

      IMAV( 1) = 12
      IMAV( 2) =  1
      IMAV( 3) =  2
      IMAV( 4) =  3
      IMAV( 5) =  4
      IMAV( 6) =  5
      IMAV( 7) =  6
      IMAV( 8) =  7
      IMAV( 9) =  8
      IMAV(10) =  9
      IMAV(11) = 10
      IMAV(12) = 11

      IHEURE   = KHEURE * 60

!  Recherche de CDDATDEB(1)
!  ------------------------

      IHHMN1   = (KHHMNM1/100)*60 + MOD( KHHMNM1 , 100 )
      IFOURHM1 = IHEURE - IHHMN1

      IF ( IFOURHM1.GE.0 ) THEN
        IAA = KANNEE
        IMM = KMOIS
        IJJ = KJOUR
        IHH = IFOURHM1 / 60
        IMN = IFOURHM1 - IHH*60
      ELSE
        IHH = ( 1440 + IFOURHM1 ) / 60
        IMN = 60 - MOD( IABS(IFOURHM1) , 60 )
        IF ( IMN.EQ.60 ) IMN = 0
        IF ( KJOUR.GT.1 ) THEN
          IAA = KANNEE
          IMM = KMOIS
          IJJ = KJOUR - 1
        ELSE
          IF ( KMOIS.EQ.1 ) THEN
            IAA = KANNEE - 1
          ELSE
            IAA = KANNEE
          ENDIF
          IMM = IMAV(KMOIS)
          IJJ = IDJM(IMM)
        ENDIF
      ENDIF

      WRITE (CDDATDEB(1)( 1: 4),'(I4)'  ) IAA
      WRITE (CDDATDEB(1)( 5: 6),'(I2.2)') IMM
      WRITE (CDDATDEB(1)( 7: 8),'(I2.2)') IJJ
      WRITE (CDDATDEB(1)( 9:10),'(I2.2)') IHH
      WRITE (CDDATDEB(1)(11:12),'(I2.2)') IMN
      CDDATDEB(1)(13:14) = '00'

!  Recherche de CDDATDEB(2)
!  ------------------------

      IHHMN2   = (KHHMNM2/100)*60 + MOD( KHHMNM2 , 100 )
      IFOURHM2 = IHEURE - IHHMN2

      IF ( IFOURHM2.GE.0 ) THEN
        IAA = KANNEE
        IMM = KMOIS
        IJJ = KJOUR
        IHH = IFOURHM2 / 60
        IMN = IFOURHM2 - IHH*60
      ELSE
        IHH = ( 1440 + IFOURHM2 ) / 60
        IMN = 60 - MOD( IABS(IFOURHM2) , 60 )
        IF ( IMN.EQ.60 ) IMN = 0
        IF ( KJOUR.GT.1 ) THEN
          IAA = KANNEE
          IMM = KMOIS
          IJJ = KJOUR - 1
        ELSE
          IF ( KMOIS.EQ.1 ) THEN
            IAA = KANNEE - 1
          ELSE
            IAA = KANNEE
          ENDIF
          IMM = IMAV(KMOIS)
          IJJ = IDJM(IMM)
        ENDIF
      ENDIF

      WRITE (CDDATDEB(2)( 1: 4),'(I4)'  ) IAA
      WRITE (CDDATDEB(2)( 5: 6),'(I2.2)') IMM
      WRITE (CDDATDEB(2)( 7: 8),'(I2.2)') IJJ
      WRITE (CDDATDEB(2)( 9:10),'(I2.2)') IHH
      WRITE (CDDATDEB(2)(11:12),'(I2.2)') IMN
      CDDATDEB(2)(13:14) = '00'

!  Recherche de CDDATDEB(3)
!  ------------------------

      IHHMN3   = (KHHMNM1/100+1)*60 + MOD( KHHMNM1 , 100 )
      IFOURHM3 = IHEURE - IHHMN3

      IF ( IFOURHM3.GE.0 ) THEN
        IAA = KANNEE
        IMM = KMOIS
        IJJ = KJOUR
        IHH = IFOURHM3 / 60
        IMN = IFOURHM3 - IHH*60
      ELSE
        IHH = ( 1440 + IFOURHM3 ) / 60
        IMN = 60 - MOD( IABS(IFOURHM3) , 60 )
        IF ( IMN.EQ.60 ) IMN = 0
        IF ( KJOUR.GT.1 ) THEN
          IAA = KANNEE
          IMM = KMOIS
          IJJ = KJOUR - 1
        ELSE
          IF ( KMOIS.EQ.1 ) THEN
            IAA = KANNEE - 1
          ELSE
            IAA = KANNEE
          ENDIF
          IMM = IMAV(KMOIS)
          IJJ = IDJM(IMM)
        ENDIF
      ENDIF

      WRITE (CDDATDEB(3)( 1: 4),'(I4)'  ) IAA
      WRITE (CDDATDEB(3)( 5: 6),'(I2.2)') IMM
      WRITE (CDDATDEB(3)( 7: 8),'(I2.2)') IJJ
      WRITE (CDDATDEB(3)( 9:10),'(I2.2)') IHH
      WRITE (CDDATDEB(3)(11:12),'(I2.2)') IMN
      CDDATDEB(3)(13:14) = '00'

!  Recherche de CDDATFIN(1)
!  ------------------------

      IHHMN1   = (KHHMNP1/100)*60 + MOD( KHHMNP1 , 100 )
      IFOURHP1 = IHEURE + IHHMN1

      IF ( IFOURHP1.LE.1439 ) THEN
        IAA = KANNEE
        IMM = KMOIS
        IJJ = KJOUR
        IHH = IFOURHP1 / 60
        IMN = IFOURHP1 - IHH*60
      ELSE
        IHH = ( IFOURHP1 - 1440 ) / 60
        IMN = IFOURHP1 - (IFOURHP1/60)*60
        IF ( KJOUR.LT.IDJM(KMOIS) ) THEN
          IAA = KANNEE
          IMM = KMOIS
          IJJ = KJOUR + 1
        ELSE
          IF ( KMOIS.EQ.12 ) THEN
            IAA = KANNEE + 1
          ELSE
            IAA = KANNEE
          ENDIF
          IMM = MOD( KMOIS , 12 ) + 1
          IJJ = 1
        ENDIF
      ENDIF

      WRITE (CDDATFIN(1)( 1: 4),'(I4)'  ) IAA
      WRITE (CDDATFIN(1)( 5: 6),'(I2.2)') IMM
      WRITE (CDDATFIN(1)( 7: 8),'(I2.2)') IJJ
      WRITE (CDDATFIN(1)( 9:10),'(I2.2)') IHH
      WRITE (CDDATFIN(1)(11:12),'(I2.2)') IMN
      CDDATFIN(1)(13:14) = '00'

!  Recherche de CDDATFIN(2)
!  ------------------------

      IHHMN2   = (KHHMNP2/100)*60 + MOD( KHHMNP2 , 100 )
      IFOURHP2 = IHEURE + IHHMN2

      IF ( IFOURHP2.LE.1439 ) THEN
        IAA = KANNEE
        IMM = KMOIS
        IJJ = KJOUR
        IHH = IFOURHP2 / 60
        IMN = IFOURHP2 - IHH*60
      ELSE
        IHH = ( IFOURHP2 - 1440 ) / 60
        IMN = IFOURHP2 - (IFOURHP2/60)*60
        IF ( KJOUR.LT.IDJM(KMOIS) ) THEN
          IAA = KANNEE
          IMM = KMOIS
          IJJ = KJOUR + 1
        ELSE
          IF ( KMOIS.EQ.12 ) THEN
            IAA = KANNEE + 1
          ELSE
            IAA = KANNEE
          ENDIF
          IMM = MOD( KMOIS , 12 ) + 1
          IJJ = 1
        ENDIF
      ENDIF

      WRITE (CDDATFIN(2)( 1: 4),'(I4)'  ) IAA
      WRITE (CDDATFIN(2)( 5: 6),'(I2.2)') IMM
      WRITE (CDDATFIN(2)( 7: 8),'(I2.2)') IJJ
      WRITE (CDDATFIN(2)( 9:10),'(I2.2)') IHH
      WRITE (CDDATFIN(2)(11:12),'(I2.2)') IMN
      CDDATFIN(2)(13:14) = '00'

!  Recherche de CDDATFIN(3)
!  ------------------------

      IHHMN3   = (KHHMNP1/100+1)*60 + MOD( KHHMNP1 , 100 )
      IFOURHP3 = IHEURE + IHHMN3

      IF ( IFOURHP3.LE.1439 ) THEN
        IAA = KANNEE
        IMM = KMOIS
        IJJ = KJOUR
        IHH = IFOURHP3 / 60
        IMN = IFOURHP3 - IHH*60
      ELSE
        IHH = ( IFOURHP3 - 1440 ) / 60
        IMN = IFOURHP3 - (IFOURHP3/60)*60
        IF ( KJOUR.LT.IDJM(KMOIS) ) THEN
          IAA = KANNEE
          IMM = KMOIS
          IJJ = KJOUR + 1
        ELSE
          IF ( KMOIS.EQ.12 ) THEN
            IAA = KANNEE + 1
          ELSE
            IAA = KANNEE
          ENDIF
          IMM = MOD( KMOIS , 12 ) + 1
          IJJ = 1
        ENDIF
      ENDIF

      WRITE (CDDATFIN(3)( 1: 4),'(I4)'  ) IAA
      WRITE (CDDATFIN(3)( 5: 6),'(I2.2)') IMM
      WRITE (CDDATFIN(3)( 7: 8),'(I2.2)') IJJ
      WRITE (CDDATFIN(3)( 9:10),'(I2.2)') IHH
      WRITE (CDDATFIN(3)(11:12),'(I2.2)') IMN
      CDDATFIN(3)(13:14) = '00'

!  Recherche de CDDATFIN(4)
!  ------------------------

      IHHMN4   = (KHHMNCO/100)*60 + MOD( KHHMNCO , 100 )
      IFOURHP4 = IHEURE + IHHMN4

      IF ( IFOURHP4.LE.1439 ) THEN
        IAA = KANNEE
        IMM = KMOIS
        IJJ = KJOUR
        IHH = IFOURHP4 / 60
        IMN = IFOURHP4 - IHH*60
      ELSE
        IHH = ( IFOURHP4 - 1440 ) / 60
        IMN = IFOURHP4 - (IFOURHP4/60)*60
        IF ( KJOUR.LT.IDJM(KMOIS) ) THEN
          IAA = KANNEE
          IMM = KMOIS
          IJJ = KJOUR + 1
        ELSE
          IF ( KMOIS.EQ.12 ) THEN
            IAA = KANNEE + 1
          ELSE
            IAA = KANNEE
          ENDIF
          IMM = MOD( KMOIS , 12 ) + 1
          IJJ = 1
        ENDIF
      ENDIF

      WRITE (CDDATFIN(4)( 1: 4),'(I4)'  ) IAA
      WRITE (CDDATFIN(4)( 5: 6),'(I2.2)') IMM
      WRITE (CDDATFIN(4)( 7: 8),'(I2.2)') IJJ
      WRITE (CDDATFIN(4)( 9:10),'(I2.2)') IHH
      WRITE (CDDATFIN(4)(11:12),'(I2.2)') IMN
      CDDATFIN(4)(13:14) = '00'

!-----------------------------------------------------------------------

      RETURN
      END
